VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ImageMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'\\ --[ ImageMapItem ]----------------------------------------------------------
'\\ Represents a single clickable region on an image map
'\\
'\\ ----------------------------------------------------------------------------
'\\ (c) 2001 Merrion Computing Ltd http://www.merrioncomputing.com
'\\ ----------------------------------------------------------------------------


'\\ Private member variable
Private msId As String
Private msName As String
Private mMapItems As Collection


'\\ Informs the parent control that the ImageMap has changed
Public Event MapChanged()

Public Function Add(ByVal HTMLText As String) As ImageMapItem

Dim tmpImageMapItem As ImageMapItem

'\\ Initialise a new image map item
Set tmpImageMapItem = New ImageMapItem

'\\ Initialise its properties
tmpImageMapItem.HTMLText = HTMLText

'\\ Add it to this collection
mMapItems.Add tmpImageMapItem

Set Add = tmpImageMapItem

End Function



Public Sub Clear()

    Set mMapItems = Nothing
    Set mMapItems = New Collection
    
End Sub

Public Property Get Count() As Long

    Count = mMapItems.Count
    
End Property

'\\ --[HTMLText]---------------------------------------------------------------
'\\ Returns this sets the ImageMap from the HTML
'\\ <map > tag.
'\\ Format:
'\\ <map id="FOO"  name="duncansimagemap">
'\\ </map>
'\\ ---------------------------------------------------------------------------
Public Property Let HTMLText(ByVal newText As String)

Dim sTmp As String
Dim sMapItemHTML As String

If Me.HTMLText <> newText Then
    msId = GetValue(newText, "id")
    msName = GetValue(newText, "name")
    sTmp = newText
    Me.Clear
    While InStr(sTmp, "<area") > 0
        sTmp = Mid$(sTmp, InStr(sTmp, "<area"))
        sMapItemHTML = Left$(sTmp, InStr(sTmp, ">"))
        Me.Add sMapItemHTML
        sTmp = Mid$(sTmp, Len(sMapItemHTML))
    Wend
    
End If

End Property


Public Property Let ImageMapid(ByVal newid As String)

If msId <> newid Then
    msId = newid
    RaiseEvent MapChanged
End If

End Property

Public Property Get ImageMapid() As String

    ImageMapid = msId
    
End Property


Public Property Get ImageMapItems() As Collection

    Set ImageMapItems = mMapItems
    
End Property

Public Property Let ImageMapname(ByVal newName As String)

If msName <> newName Then
    msName = newName
    RaiseEvent MapChanged
End If

End Property

Public Property Get ImageMapname() As String

    ImageMapname = msName
    
End Property


'\\ --[NextFreeId]--------------------------------------------------
'\\ Returns an unique id for a new area of a given shape to add
'\\ to the current image map control
'\\ ----------------------------------------------------------------
Friend Property Get NextFreeId(ByVal newShape As enImageMapItemShapes) As String

Dim lIndex As Long
Dim sShapeKey As String
Dim tmpImageMapItem As ImageMapItem

'\\ For readability, add the shape into the index
Select Case newShape
Case imsCircle
    sShapeKey = "circ_"
Case imsRectangle
    sShapeKey = "rect_"
Case imsPolygon
    sShapeKey = "poly_"
End Select

'\\ Find the next index
For lIndex = 1 To 32000
    On Error Resume Next
    Set tmpImageMapItem = ImageMapItems(sShapeKey & lIndex)
    If tmpImageMapItem Is Nothing Then
        '\\ No matching key..
        NextFreeId = sShapeKey & lIndex
        Exit For
    End If
Next lIndex

End Property

Private Sub Class_Initialize()

    Set mMapItems = New Collection

End Sub

Private Sub Class_Terminate()

    Set mMapItems = Nothing
    
End Sub

'\\ --[HTMLText]---------------------------------------------------------------
'\\ Returns this ImageMap as it would appear in an HTML document as an
'\\ <map > tag.
'\\ Format:
'\\ <map id="FOO"  name="duncansimagemap">
'\\ </map>
'\\ ---------------------------------------------------------------------------
Public Property Get HTMLText() As String

Dim sMap As String
Dim tmpImageMapItem As ImageMapItem

sMap = "<map"

'\\ Write the id
If msId <> "" Then
    sMap = sMap & " id=" & QuoteString(msId)
End If

'\\ Write the name
If msName <> "" Then
    sMap = sMap & " name=" & QuoteString(msName)
End If

'\\ Close the HTML tag
sMap = sMap & ">"

'\\ Add all the ImageMapItems.HTMLText items
For Each tmpImageMapItem In mMapItems
    sMap = sMap & tmpImageMapItem.HTMLText
Next tmpImageMapItem

'\\ Add the tag terminator
sMap = sMap & "</map>"

HTMLText = sMap

End Property

Public Property Get item(vntIndexKey As Variant) As ImageMapItem
    'used when referencing an element in the collection
    'vntIndexKey contains either the Index or Key to the collection,
    'this is why it is declared as a Variant
    'Syntax: Set foo = x.Item(xyz) or Set foo = x.Item(5)
  Set item = mMapItems(vntIndexKey)
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = 0
    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Set NewEnum = mMapItems.[_NewEnum]
End Property


Public Sub Remove(vntIndexKey As Variant)
    'used when removing an element from the collection
    'vntIndexKey contains either the Index or Key, which is why
    'it is declared as a Variant
    'Syntax: x.Remove(xyz)

    mMapItems.Remove vntIndexKey
    
    '\\ Inform the container of this change
    RaiseEvent MapChanged
    
End Sub
