VERSION 5.00
Begin VB.UserControl VBImageMap 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   320
   ToolboxBitmap   =   "VBImageMap.ctx":0000
   Begin VB.Image imgBackdrop 
      Height          =   2175
      Left            =   480
      Top             =   600
      Width           =   3015
   End
   Begin VB.Menu mnuOptionPopup 
      Caption         =   "Options"
      Begin VB.Menu mnuNew 
         Caption         =   "New "
         Begin VB.Menu mnuRgnCircle 
            Caption         =   "Circular Region"
         End
         Begin VB.Menu mnuRgnRect 
            Caption         =   "Rectangular Region"
         End
         Begin VB.Menu mnuRgnPoly 
            Caption         =   "Polygonal Region"
         End
      End
      Begin VB.Menu mnuSeparator1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuProperties 
         Caption         =   "Properties"
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuSeparator2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAbout 
         Caption         =   "About"
         Shortcut        =   {F1}
      End
   End
End
Attribute VB_Name = "VBImageMap"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'\\ --[ VBImageMap ]----------------------------------------------------------
'\\ This is the control that emulates the client side imagemap
'\\
'\\ ----------------------------------------------------------------------------
'\\ (c) 2001 Merrion Computing Ltd http://www.merrioncomputing.com
'\\ ----------------------------------------------------------------------------

Option Explicit


'\\ Store the default window proc for this control when subclassing
Private mPreviousWndProc


'Default Property Values:
Const m_def_BackColor = 0
Const m_def_ForeColor = 0
Const m_def_Enabled = 0
Const m_def_BackStyle = 0
Const m_def_BorderStyle = 0

Dim m_def_htmltext As String

'Property Variables:
Dim m_BackColor As Long
Dim m_ForeColor As Long
Dim m_Enabled As Boolean
Dim m_Font As Font
Dim m_BackStyle As Integer
Dim m_BorderStyle As Integer
Private m_Picture As Picture

'Event Declarations:
Event Click()
Attribute Click.VB_Description = "Occurs when the user presses and then releases a mouse button over an object."
Event DblClick()
Attribute DblClick.VB_Description = "Occurs when the user presses and releases a mouse button and then presses and releases it again over an object."
Event KeyDown(KeyCode As Integer, Shift As Integer)
Attribute KeyDown.VB_Description = "Occurs when the user presses a key while an object has the focus."
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event KeyUp(KeyCode As Integer, Shift As Integer)
Attribute KeyUp.VB_Description = "Occurs when the user releases a key while an object has the focus."
Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseDown.VB_Description = "Occurs when the user presses the mouse button while an object has the focus."
Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseMove.VB_Description = "Occurs when the user moves the mouse."
Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
Attribute MouseUp.VB_Description = "Occurs when the user releases the mouse button while an object has the focus."

'\\ Extra events
Event MapItemClicked(ByVal item As ImageMapItem)  'Triggered when a click occurs over an imagemap item
Event MapItemMouseOver(ByVal item As ImageMapItem) 'Triggered when the mouse is moved over a mapitem

'\\ Private imagemap object
Private WithEvents mImageMap As ImageMap
Attribute mImageMap.VB_VarHelpID = -1

Public Enum enControlMode
   cm_Runtime = 1          '\\ The control is in runtime mode
   cm_DesignTime_Selecting = 2 '\\ Control is design time but no ImageMapItem is selected
   cm_DesignTime_Selected = 3 '\\ Control is in design time and an ImageMapItem is selected
   cm_DesignTime_Drawing = 4 '\\ Control is drawing a new ImageMapItem
End Enum

Private mCurrentMode As enControlMode

'\\ This is a reference to the currently selected image map item,
'\\ if any
Private mSelectedItem As ImageMapItem
Private mHoverItem As ImageMapItem

'\\ Holds the mouse position and the Id of the currently hovered
'\\ over map item (if any) for UI tooltip feedback
Private mToolTipText As String

Public Property Get ControlMode() As enControlMode

ControlMode = mCurrentMode

End Property


Public Property Let ControlMode(ByVal newmode As enControlMode)

If newmode <> mCurrentMode Then
    '\\ The mode has changed - alter the display as appropriate
    Select Case newmode
    Case cm_DesignTime_Selecting
        mnuNew.Enabled = True
        
    Case cm_DesignTime_Selected
        mnuNew.Enabled = True
        
    Case cm_DesignTime_Drawing
        mnuNew.Enabled = True
        
    Case cm_Runtime
        mnuNew.Enabled = False
        
    End Select
    mCurrentMode = newmode
End If

End Property





Public Property Let HTMLText(ByVal newText As String)

    mImageMap.HTMLText = newText
    
    PropertyChanged ("HTMLText")
    
End Property

Public Property Get HTMLText() As String

    HTMLText = mImageMap.HTMLText
    
End Property



Public Property Get hWnd() As Long

    hWnd = UserControl.hWnd
    
End Property

Public Property Let ImageMapid(ByVal newid As String)

    mImageMap.ImageMapid = newid
    
End Property

Public Property Get ImageMapid() As String

ImageMapid = mImageMap.ImageMapid

End Property

'\\ --[ImageMapItemAtPoint]----------------------------------------------------
'\\ Returns the image map item at the given point by 'asking' each in turn
'\\ to see which the point is in
'\\ ---------------------------------------------------------------------------
Private Property Get ImageMapItemAtPoint(ByVal x As Long, ByVal y As Long) As ImageMapItem

Dim imiThis As ImageMapItem

    For Each imiThis In mImageMap.ImageMapItems
        If imiThis.ContainsPoint(x, y) Then
            Set ImageMapItemAtPoint = imiThis
            Exit For
        End If
    Next imiThis
        
End Property

Public Property Let ImageMapname(ByVal newName As String)

    mImageMap.ImageMapname = newName
    
End Property

Public Property Get ImageMapname() As String

    ImageMapname = mImageMap.ImageMapname
    
End Property


Friend Property Get Key() As String

    Key = MakeKey(UserControl.hWnd)
    
End Property

Friend Property Let PreviousWindowProc(ByVal newProc As Long)

    mPreviousWndProc = newProc
    
End Property

Friend Property Get PreviousWindowProc() As Long

    PreviousWindowProc = mPreviousWndProc
    
End Property

Private Property Set SelectedItem(ByVal theItem As ImageMapItem)

If theItem Is Nothing Then
    Set mSelectedItem = Nothing
    mnuProperties.Enabled = False
Else
    Set mSelectedItem = theItem
    mnuProperties.Enabled = True
End If

End Property

'\\ --[ShowProperties]----------------------------------------------
'\\ Brings up the image map item properties screen to allow the
'\\ user to alter the properties.
'\\ ----------------------------------------------------------------
Private Sub ShowProperties(item As ImageMapItem)

Dim fProperties As frmIMIProperties

Set fProperties = New frmIMIProperties

With fProperties
    Set .ImageMapItem = item
    .Show vbModal
End With

End Sub

'\\ -- [ WindowProcFired ] ---------------------------------------------------------
'\\ This procedure is fired whenever a window message is recieved by the subclasser
'\\ for this control.  Setting override forces the default processing to be ignored.
'\\ (You have to implement the processing in that case)
'\\ ---------------------------------------------------------------------------------
Friend Sub WindowProcFired(ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long, OverRide As Long)

Dim x As Single, y As Single
Dim imiThis As ImageMapItem

On Error Resume Next

Select Case wMsg

Case WM_LBUTTONDOWN, WM_LBUTTONUP, WM_MOUSEMOVE, WM_RBUTTONUP
    '\\ Get the x,y position the click occured at
    x = LoWord(lParam)
    y = HiWord(lParam)
    '\\ Process the particular mouse message
    Set imiThis = ImageMapItemAtPoint(x, y)
    If wMsg = WM_LBUTTONDOWN Then
        '\\ Additional mousedown processing...
        If Not (imiThis Is Nothing) Then
            Set SelectedItem = imiThis
        Else
            Set SelectedItem = Nothing
        End If
        '\\ What happens on a click depends on what mode we are in
        Select Case mCurrentMode
        Case cm_Runtime
            '\\ In run mode, raise an event
            If Not (imiThis Is Nothing) Then
                RaiseEvent MapItemClicked(imiThis)
            End If
        End Select
        
        
    ElseIf wMsg = WM_MOUSEMOVE Then
        mToolTipText = "(" & x & "," & y & ")"
        '\\ If the mouse is hovering over a defined image map item then
        '\\ add this to the tooltip feedback
        If Not (imiThis Is Nothing) Then
            mToolTipText = imiThis.ImageMapItemId & " - " & mToolTipText
        Else
            mToolTipText = "Background - " & mToolTipText
        End If
        Select Case Me.ControlMode
        Case cm_Runtime
            '\\ If the item being hovered over is not the same as the
            '\\ previous item the mouse was over, raise the MapItemMouseOver
            '\\ event
            If Not (imiThis = mHoverItem) Then
                If imiThis Is Nothing Then
                    Set mHoverItem = Nothing
                Else
                    Set mHoverItem = imiThis
                End If
                RaiseEvent MapItemMouseOver(mHoverItem)
            End If
        End Select
        
        
    ElseIf wMsg = WM_RBUTTONUP Then
        PopupMenu mnuOptionPopup, , x, y
    End If
End Select

End Sub

Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute BackColor.VB_UserMemId = -501
    BackColor = m_BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    m_BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = "StandardColor;Appearance"
Attribute ForeColor.VB_UserMemId = -513
    ForeColor = m_ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    m_ForeColor = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = m_Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    m_Enabled = New_Enabled
    PropertyChanged "Enabled"
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = m_Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set m_Font = New_Font
    PropertyChanged "Font"
End Property

Public Property Get BackStyle() As Integer
Attribute BackStyle.VB_Description = "Indicates whether a Label or the background of a Shape is transparent or opaque."
Attribute BackStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackStyle.VB_UserMemId = -502
    BackStyle = m_BackStyle
End Property

Public Property Let BackStyle(ByVal New_BackStyle As Integer)
    m_BackStyle = New_BackStyle
    PropertyChanged "BackStyle"
End Property

Public Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
    BorderStyle = m_BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As BorderStyleConstants)
    m_BorderStyle = New_BorderStyle
    PropertyChanged "BorderStyle"
End Property

Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
Attribute Refresh.VB_UserMemId = -550
     
End Sub

Property Get Picture() As Picture
    Set Picture = imgBackdrop.Picture
End Property

Property Let Picture(Valor As Picture)
    Set m_Picture = Valor
    Set imgBackdrop.Picture = Valor
    PropertyChanged ("Picture")
End Property

' asigna la imagen al picturebox
Property Set Picture(Valor As Picture)
    Set m_Picture = Valor
    Set imgBackdrop.Picture = Valor
End Property


Private Sub mnuAbout_Click()

frmAbout.Show vbModal

End Sub

Private Sub mnuProperties_Click()

Call ShowProperties(mSelectedItem)

End Sub

Private Sub mnuRgnCircle_Click()

Dim tmpCircle As ImageMapItem

Set tmpCircle = New ImageMapItem

With tmpCircle
    .Shape = imsCircle
    .ImageMapItemId = mImageMap.NextFreeId(imsCircle)
End With
Call ShowProperties(mImageMap.Add(tmpCircle.HTMLText))

End Sub

Private Sub mnuRgnPoly_Click()

Dim tmpPoly As ImageMapItem

Set tmpPoly = New ImageMapItem

With tmpPoly
    .Shape = imsPolygon
    .ImageMapItemId = mImageMap.NextFreeId(.Shape)
End With
Call ShowProperties(mImageMap.Add(tmpPoly.HTMLText))

End Sub


Private Sub mnuRgnRect_Click()

Dim tmpRect As ImageMapItem

Set tmpRect = New ImageMapItem

With tmpRect
    .Shape = imsRectangle
    .ImageMapItemId = mImageMap.NextFreeId(.Shape)
End With
Call ShowProperties(mImageMap.Add(tmpRect.HTMLText))

End Sub


Private Sub UserControl_Initialize()

m_def_htmltext = "<map id=" & QuoteString("Default") & " name=" & QuoteString("MerrionComputingLtd_ImageMap") & "></map>"

Set mImageMap = New ImageMap

ImageMapSubs.ConnectImageMapControl Me

End Sub


'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    m_BackColor = m_def_BackColor
    m_ForeColor = m_def_ForeColor
    m_Enabled = m_def_Enabled
    Set m_Font = Ambient.Font
    m_BackStyle = m_def_BackStyle
    m_BorderStyle = m_def_BorderStyle
    Set m_Picture = LoadPicture("")
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)

If Button = vbRightButton Then
    '\\ Show the popup menu
    PopupMenu mnuOptionPopup
End If

End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    m_BackColor = PropBag.ReadProperty("BackColor", m_def_BackColor)
    m_ForeColor = PropBag.ReadProperty("ForeColor", m_def_ForeColor)
    m_Enabled = PropBag.ReadProperty("Enabled", m_def_Enabled)
    Set m_Font = PropBag.ReadProperty("Font", Ambient.Font)
    m_BackStyle = PropBag.ReadProperty("BackStyle", m_def_BackStyle)
    m_BorderStyle = PropBag.ReadProperty("BorderStyle", m_def_BorderStyle)
    Set m_Picture = PropBag.ReadProperty("Picture", Nothing)
    'If m_Picture.Handle <> 0 Then
        Set Me.Picture = m_Picture
    'End If

    Me.HTMLText = PropBag.ReadProperty("HTMLText", m_def_htmltext)
    
End Sub

Private Sub UserControl_Resize()

'\\ Make sure that the image control occupies the entire
'\\ usercontrol area
With imgBackdrop
    .Left = 0
    .Top = 0
    .Width = UserControl.Width
    .Height = UserControl.Height
End With

End Sub

Private Sub UserControl_Terminate()

Set mImageMap = Nothing

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("BackColor", m_BackColor, m_def_BackColor)
    Call PropBag.WriteProperty("ForeColor", m_ForeColor, m_def_ForeColor)
    Call PropBag.WriteProperty("Enabled", m_Enabled, m_def_Enabled)
    Call PropBag.WriteProperty("Font", m_Font, Ambient.Font)
    Call PropBag.WriteProperty("BackStyle", m_BackStyle, m_def_BackStyle)
    Call PropBag.WriteProperty("BorderStyle", m_BorderStyle, m_def_BorderStyle)
    Call PropBag.WriteProperty("Picture", m_Picture, Nothing)
    
    Call PropBag.WriteProperty("HTMLText", Me.HTMLText, m_def_htmltext)
    
End Sub

